package main

import "fmt"
import "os"
import "bytes"
import "time"
import "io"
import "strings"

func wordCarousel(display []rune, pos *int, l int) string {
    buf := &bytes.Buffer{}
    
    for i := 0; i != l ;i++ {
        idx := i + *pos
        if idx >= len(display) {
            idx -= len(display)
        }
        buf.WriteRune(display[idx])
    }
    *pos++;
    if *pos >= len(display) {
        *pos = 0;
        panic("pos has been reset") // added statement to check if this is hit
    }
    return buf.String()
}

func main() {
    buf := &bytes.Buffer{}
    _, err := io.Copy(buf, os.Stdin)
    if err != nil {
        panic(err)
    }
    display := []rune(strings.TrimSpace(buf.String()))
    fmt.Fprint(os.Stdout, "\n")
    var pos int
    for {
        fmt.Fprint(os.Stdout,"\r")
        displayIteration := wordCarousel(display, &pos, 21)
        fmt.Fprint(os.Stdout, displayIteration)
        time.Sleep(220 * time.Millisecond)
    }
}
